%{
===========================================================================
Code provided by Yichuan (Charlie) Tang
Permission is granted for anyone to copy, use, modify, or distribute this
program and accompanying programs and documents for any purpose, provided
this copyright notice is retained and prominently displayed, along with
a note saying that the original programs are available from our
web page.
The programs and documents are distributed without any warranty, express or
implied.  As the programs were written for research purposes only, they 
have not been tested to the degree that would be advisable in any important
application.  All use of these programs is entirely at the user's own risk.
===========================================================================

CT 3/2012 
% able to work with any number of z's
multiplies a matriczied tensor T [D x (d1 * d2 * d3 ...)] with a matrices zs{k} of d(k) by N
returns matrices W = [ D x d(?) x N ]

zs{1:d3} is a cell, each cell has dim by N samples, from one component
d: dimensionality = [d1=2 d2=5 d3=10]
inds: which index of zs do we want to multiply by. e.g. 1
thisinds: the random variable's index
%assume inds is from smallest to largest
% e.g. [2 3 4]

inds, thisind is 1-based and w.r.t. d, not TT
%}
function [W] = TensorMatrixProd_zs(T, d, zs, inds, thisind)

D = size(T,1);
N = size(zs{1},2);
assert(size(T,2) == prod(d) );
assert(length(thisind) ==1);
assert(length(inds) == length(d)-1);

TT = tensor(reshape(T, [D, d]),[D d]); %easier to use tensor matrix product

highest_mode = inds(end)+1;  %+1 since TT's mode-1 is D
d_this = thisind+1;

temp0 = ttm(TT, zs{inds(end)}', highest_mode); %multiply highest mode's data
temp = temp0;
for i =length(inds)-1:-1:1
    mode = inds(i)+1;  %+1 since TT's mode-1 is D
    if 0 %below shouldbe the same algorithm
        temp2 = tensor(zs{inds(i)}, [d(inds(i)) N]); 
        temp = scale(temp0, temp2, [mode highest_mode]);

        temp = tensor( sum(temp.data, mode ) );
        
    else
        reshapeinds = ones(1, length(d)+1);
        reshapeinds(mode) = size(zs{inds(i)},1);
        reshapeinds(highest_mode) = N;        
        temp2 = reshape( zs{inds(i)}, reshapeinds);
        repmatinds = size(temp);
        repmatinds(mode)=1;
        repmatinds(highest_mode)=1;
        temp2 = repmat(temp2, repmatinds);
        temp = tensor( sum(temp2.*temp.data, mode ) );
    end
    
    assert(d_this ~= mode);
    if d_this > mode
        d_this = d_this-1;
    end
end
temp = tensor( squeeze(temp.data ) );
mat = tenmat(temp, [1 d_this]);            % sort of shift the dimensions (from D x N x d2), since we want N to be 3rd dimension
W = reshape(mat.data, [D, d(thisind), N]);    % reshape so we have D x d2 x N



